# AUTOGENERATED! DO NOT EDIT! File to edit: nbs/cli.ipynb (unless otherwise specified).

__all__ = ['app', 'scrap', 'parallel', 'cli']

# Cell
from pathlib import Path
from typing import List

import typer

from .downloader import GoogleImageDownloader
from .paralel import ParalelDownload

# Cell
app = typer.Typer()

# Cell


@app.command()
def scrap(
    n_item: int = typer.Argument(..., help="The number of element you want to scrap"),
    query: str = typer.Argument(..., help="The query for your scrapping"),
    path: Path = typer.Argument(
        Path("."), help="The folder where to download the dataset"
    ),
):
    GoogleImageDownloader(str(path)).download(query, n_item)

# Cell


@app.command()
def parallel(
    n_item: int = typer.Argument(..., help="The number of element you want to scrap"),
    queries: List[str] = typer.Argument(..., help="The queries for your scrapping"),
    path: Path = typer.Argument(
        Path("."), help="The folder where to download the dataset"
    ),
    num_workers: int = typer.Argument(4, help="The number of worker"),
):

    num_workers = min(num_workers, len(queries))
    ParalelDownload(str(path), GoogleImageDownloader, num_workers=num_workers).download(
        list(queries), n_item
    )

# Cell


def cli():
    app()


if __name__ == "__main__":
    from IPython import get_ipython

    if not get_ipython():
        cli()
    else:
        print("running in a notebook")