# AUTOGENERATED! DO NOT EDIT! File to edit: nbs/torch_dataset.ipynb (unless otherwise specified).

__all__ = ['TorchDataset']

# Cell
from typing import Callable

from docarray import Document, DocumentArray
from torch.utils.data import Dataset
from torchvision.datasets.folder import default_loader
import torchvision as tv

# Cell
class TorchDataset(Dataset):
    """
    A torch dataset for web2dataset  that you can use to train model with pytorch
    """

    def __init__(self, path: str ,transform : Callable = tv.transforms.ToTensor()):
        """
        path: folder from where to load the web2dataset dataset
        transform: a torchvision transform function to apply augmentation and converstion
        """
        self.path = path
        self.transform = transform

        with open(f"{path}/dataset.bin", "rb") as f:
            self.docs = DocumentArray.from_bytes(f.read())

    def __getitem__(self, key):

        document = self.docs[key]
        tensor = default_loader(f"{self.path}/{document.uri}")
        tensor = self.transform(tensor)

        return tensor, document.tags

    def __len__(self):
        return len(self.docs)